/****************************************************************************
   Copyright (C) 2008-2009, Orcan Ogetbil. All rights reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*****************************************************************************/

#ifndef MELEKGAME_H
#define MELEKGAME_H

#include <kbuttongroup.h>
#include <QGridLayout>
#include <QSignalMapper>
#include <QLCDNumber>
#include <QLabel>
#include "board.h"

using namespace blueangel;

class MelekGame : public QObject
{
 Q_OBJECT

 public:

  MelekGame(KButtonGroup *buttonGroup, QLCDNumber *lcd1, QLCDNumber *lcd2, int length, int dimension);

  int difficulty;
  //int dimension;
  int players;
  void setDifficulty(int depth);
  void gameOn(int index1, int index2, int value);
  void restartGame();
  void restartGame(int size);

  int mdimension;

 public slots:
  void clicked(const QString &text);

 private:
  vector< vector< KPushButton* > > buttonell;

  int getElementFromAI(int& coord_row, int& coord_col);
  void setScore(int player1score, int player2score);
  void colorize(int playerturn, int element);
  void newGame();
  void gameOver();

  QLabel *gameOverString;

  QGridLayout *buttonsLayout;

  QSignalMapper *signalMapper;

  QLCDNumber *mlcd1;
  QLCDNumber *mlcd2;
  KButtonGroup *mbutgrp;
  int mlength;
  //  QFont buttonFont;

  Board *m_board;


  int turn;
  int score1;
  int score2;
  int temprow;
  int tempcol;
  
};

#endif
